'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactQuill = require('react-quill');

var _reactQuill2 = _interopRequireDefault(_reactQuill);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _pathHelpers = require('../helpers/pathHelpers');

var _RichTextInput = require('../../styles/cspace-input/RichTextInput.css');

var _RichTextInput2 = _interopRequireDefault(_RichTextInput);

require('!style-loader!css-loader!../../styles/quill/cspace.css');

require('!style-loader!css-loader!react-quill/dist/quill.core.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* global window */

/* eslint-disable import/imports-first, import/no-unresolved */


/* eslint-enable import/imports-first, import/no-unresolved */

// Change bold rendering to <b> instead of <strong>, since it is more semantically neutral.

var Bold = _reactQuill.Quill.import('formats/bold');
Bold.tagName = 'B';
_reactQuill.Quill.register(Bold, true);

// Change italic rendering to <i> instead of <em>, since it is more semantically neutral.

var Italic = _reactQuill.Quill.import('formats/italic');
Italic.tagName = 'I';
_reactQuill.Quill.register(Italic, true);

var normalizeValue = function normalizeValue(value) {
  var normalizedValue = value;

  if (normalizedValue) {
    // If there is only a single paragraph, remove the <p></p> wrapper.

    if (normalizedValue.indexOf('<p>', 1) < 0) {
      normalizedValue = normalizedValue.replace(/^<p>|<\/p>$/g, '');
    }

    // If content is '<br>', set it to empty. Quill uses this as a placeholder.

    if (normalizedValue === '<br>') {
      normalizedValue = '';
    }
  }

  return normalizedValue;
};

var preventButtonMouseDown = function preventButtonMouseDown(event) {
  if (event.target.nodeName === 'BUTTON') {
    // On mouseDown on a toolbar button, Firefox fires a blur event with null relatedTarget. This
    // would be fine, if relatedTarget were correctly set to the toolbar button. But since it's
    // null, the toolbar disappears. Prevent this.

    event.preventDefault();
  }
};

var propTypes = {
  embedded: _propTypes2.default.bool,
  multiline: _propTypes2.default.bool,
  /* eslint-disable react/no-unused-prop-types */
  name: _propTypes2.default.string,
  parentPath: _pathHelpers.pathPropType,
  subpath: _pathHelpers.pathPropType,
  /* eslint-enable react/no-unused-prop-types */
  value: _propTypes2.default.string,
  readOnly: _propTypes2.default.bool,
  onCommit: _propTypes2.default.func
};

var RichTextInput = function (_Component) {
  _inherits(RichTextInput, _Component);

  function RichTextInput(props) {
    _classCallCheck(this, RichTextInput);

    // Set the allowed formats.
    // TODO: Make this a prop.
    // TODO: Add paragraph formatting (e.g. lists) when multiline is true?

    var _this = _possibleConstructorReturn(this, (RichTextInput.__proto__ || Object.getPrototypeOf(RichTextInput)).call(this, props));

    _this.formats = ['bold', 'italic', 'underline', 'script'];

    // Configure the toolbar buttons.
    // TODO: Make this a prop.

    _this.modules = {
      keyboard: {
        bindings: {
          // Only allow newlines in content if multiline prop is true.

          enter: {
            key: 13,
            handler: function handler() {
              _this.commit();

              return !!_this.props.multiline;
            }
          },

          // Don't allow tabs in the content, just do the browser default of focusing the next
          // field.

          tab: null
        }
      },
      toolbar: ['bold', 'italic', 'underline', { script: 'sub' }, { script: 'super' }, 'clean']
    };

    // TODO: Make a custom HTML toolbar for accessibility:
    // https://github.com/zenoamaro/react-quill#html-toolbar

    _this.state = {
      value: _this.props.value
    };

    _this.handleBlur = _this.handleBlur.bind(_this);
    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleRef = _this.handleRef.bind(_this);
    return _this;
  }

  _createClass(RichTextInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        value: nextProps.value
      });
    }
  }, {
    key: 'commit',
    value: function commit() {
      var _props = this.props,
          onCommit = _props.onCommit,
          prevValue = _props.value;


      if (onCommit) {
        var value = normalizeValue(this.state.value);

        if (value !== prevValue) {
          onCommit((0, _pathHelpers.getPath)(this.props), value);
        }
      }
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur(event) {
      var _this2 = this;

      if (!this.domNode.contains(event.relatedTarget)) {
        window.setTimeout(function () {
          _this2.setState({
            focused: false
          });

          _this2.commit();
        }, 0);
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(value) {
      this.setState({
        value: value
      });
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(event) {
      if (!this.domNode.contains(event.relatedTarget)) {
        this.setState({
          focused: true
        });
      }
    }
  }, {
    key: 'handleRef',
    value: function handleRef(ref) {
      this.domNode = ref;
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames;

      var _props2 = this.props,
          embedded = _props2.embedded,
          multiline = _props2.multiline,
          readOnly = _props2.readOnly;
      var _state = this.state,
          focused = _state.focused,
          value = _state.value;


      var normalizedValue = value || '';

      var className = (0, _classnames2.default)((_classNames = {}, _defineProperty(_classNames, _RichTextInput2.default.embedded, embedded), _defineProperty(_classNames, _RichTextInput2.default.normal, !embedded), _defineProperty(_classNames, _RichTextInput2.default.enabled, !readOnly), _defineProperty(_classNames, _RichTextInput2.default.multiline, multiline), _defineProperty(_classNames, _RichTextInput2.default.focus, focused), _classNames));

      // The react-quill onBlur event is unreliable, so the wrapper div here is used to do our own
      // implementation.
      // https://github.com/zenoamaro/react-quill/issues/286
      // https://github.com/zenoamaro/react-quill/issues/276

      return _react2.default.createElement(
        'div',
        {
          ref: this.handleRef,
          onBlur: this.handleBlur,
          onFocus: this.handleFocus,
          onMouseDown: preventButtonMouseDown
        },
        _react2.default.createElement(_reactQuill2.default, {
          className: className,
          formats: this.formats,
          modules: this.modules,
          readOnly: readOnly,
          theme: 'snow',
          value: normalizedValue,
          onChange: this.handleChange
        })
      );
    }
  }]);

  return RichTextInput;
}(_react.Component);

exports.default = RichTextInput;


RichTextInput.propTypes = propTypes;